diff --git a/lustre/include/lustre_dlm.h b/lustre/include/lustre_dlm.h
index 27feb6f..8c5553a 100644
--- a/lustre/include/lustre_dlm.h
+++ b/lustre/include/lustre_dlm.h
@@ -34,14 +34,20 @@
  * Lustre is a trademark of Sun Microsystems, Inc.
  */
 
-#ifndef _LUSTRE_DLM_H__
-#define _LUSTRE_DLM_H__
-
-/** \defgroup ldlm ldlm
+/** \defgroup LDLM Lustre Distributed Lock Manager
+ *
+ * Lustre DLM is based on VAX DLM.
+ * It's two main roles are:
+ *   - to provide locking assuring consistency of data on all Lustre nodes
+ *   - to assure a way for clients to cache state protected by a lock by not
+ *     actually releasing the lock.
  *
  * @{
  */
 
+#ifndef _LUSTRE_DLM_H__
+#define _LUSTRE_DLM_H__
+
 #if defined(__linux__)
 #include <linux/lustre_dlm.h>
 #elif defined(__APPLE__)
@@ -73,6 +79,9 @@ struct obd_device;
 #define LDLM_DEFAULT_MAX_ALIVE (cfs_time_seconds(36000))
 #define LDLM_CTIME_AGE_LIMIT (10)
 
+/**
+ * LDLM non-error return states
+ */
 typedef enum {
         ELDLM_OK = 0,
 
@@ -85,6 +94,13 @@ typedef enum {
         ELDLM_BAD_NAMESPACE    = 401
 } ldlm_error_t;
 
+/**
+ * LDLM namespace type.
+ * the "client" type is actually an indication that this is a narrow local view
+ * into complete namespace on the server. Such namespaces cannot make any
+ * decisions about lack of conflicts or do any autonomous lock granting without
+ * first speaking to a server
+ */
 typedef enum {
         LDLM_NAMESPACE_SERVER = 1 << 0,
         LDLM_NAMESPACE_CLIENT = 1 << 1
@@ -92,9 +108,11 @@ typedef enum {
 
 #define LDLM_FL_LOCK_CHANGED   0x000001 /* extent, mode, or resource changed */
 
-/* If the server returns one of these flags, then the lock was put on that list.
+/**
+ * If the server returns one of these flags, then the lock was put on that list.
  * If the client sends one of these flags (during recovery ONLY!), it wants the
- * lock added to the specified list, no questions asked. -p */
+ * lock added to the specified list, no questions asked. -p
+ */
 #define LDLM_FL_BLOCK_GRANTED  0x000002
 #define LDLM_FL_BLOCK_CONV     0x000004
 #define LDLM_FL_BLOCK_WAIT     0x000008
@@ -105,8 +123,10 @@ typedef enum {
 #define LDLM_FL_WAIT_NOREPROC  0x000040 /* not a real flag, not saved in lock */
 #define LDLM_FL_CANCEL         0x000080 /* cancellation callback already run */
 
-/* Lock is being replayed.  This could probably be implied by the fact that one
- * of BLOCK_{GRANTED,CONV,WAIT} is set, but that is pretty dangerous. */
+/**
+ * Lock is being replayed.  This could probably be implied by the fact that one
+ * of BLOCK_{GRANTED,CONV,WAIT} is set, but that is pretty dangerous.
+ */
 #define LDLM_FL_REPLAY         0x000100
 
 #define LDLM_FL_INTENT_ONLY    0x000200 /* don't grant lock, just do intent */
@@ -124,7 +144,7 @@ typedef enum {
 #define LDLM_FL_NO_TIMEOUT     0x020000 /* Blocked by group lock - wait
                                          * indefinitely */
 
-/* file & record locking */
+/** file & record locking */
 #define LDLM_FL_BLOCK_NOWAIT   0x040000 // server told not to wait if blocked
 #define LDLM_FL_TEST_LOCK      0x080000 // return blocking lock
 
@@ -192,7 +212,7 @@ typedef enum {
 /* Flags sent in AST lock_flags to be mapped into the receiving lock. */
 #define LDLM_AST_FLAGS         (LDLM_FL_DISCARD_DATA)
 
-/* 
+/**
  * --------------------------------------------------------------------------
  * NOTE! Starting from this point, that is, LDLM_FL_* flags with values above
  * 0x80000000 will not be sent over the wire.
@@ -200,15 +220,20 @@ typedef enum {
  */
 
 /* Used for marking lock as an target for -EINTR while cp_ast sleep
- * emulation + race with upcoming bl_ast.  */
+ * emulation + race with upcoming bl_ast. 
+ */
 #define LDLM_FL_FAIL_LOC       0x100000000ULL
 
-/* The blocking callback is overloaded to perform two functions.  These flags
+/**
+ * The blocking callback is overloaded to perform two functions.  These flags
  * indicate which operation should be performed. */
 #define LDLM_CB_BLOCKING    1
 #define LDLM_CB_CANCELING   2
 
-/* compatibility matrix */
+/**
+ * compatibility matrix.
+ * Defines what lock modes are compatible with what other lock modes
+ */
 #define LCK_COMPAT_EX  LCK_NL
 #define LCK_COMPAT_PW  (LCK_COMPAT_EX | LCK_CR)
 #define LCK_COMPAT_PR  (LCK_COMPAT_PW | LCK_PR)
@@ -245,8 +270,8 @@ static inline int lockmode_compat(ldlm_mode_t exist_mode, ldlm_mode_t new_mode)
    -
 */
 
-/*
- * Locking rules:
+/**
+ * Locking rules for LDLM:
  *
  * lr_lock
  *
@@ -269,8 +294,18 @@ struct ldlm_lock;
 struct ldlm_resource;
 struct ldlm_namespace;
 
+/**
+ * Operation on ldlm pools.
+ * LDLM pool is a pool of locks in the namespace without any implicitly
+ * specified limits.
+ * Locks in the pool are organized in LRU.
+ * Local memory pressure or server instructions (e.g. mempressure on server)
+ * can trigger freeing of locks from the pool
+ */
 struct ldlm_pool_ops {
+        /** Recalculate pool \param pl usage */
         int (*po_recalc)(struct ldlm_pool *pl);
+        /** Cancel at least \param nr locks from pool \pl */
         int (*po_shrink)(struct ldlm_pool *pl, int nr,
                          unsigned int gfp_mask);
         int (*po_setup)(struct ldlm_pool *pl, int limit);
@@ -296,6 +331,11 @@ struct ldlm_pool_ops {
  */
 #define LDLM_POOL_CLI_DEF_RECALC_PERIOD (10)
 
+/**
+ * LDLM pool structure to track granted locks.
+ * For purposes of determining when to release locks on e.g. memory pressure.
+ * Teh feature is commonly referred to as lru_resize.
+ */
 struct ldlm_pool {
         /**
          * Pool proc directory.
@@ -368,6 +408,14 @@ typedef int (*ldlm_res_policy)(struct ldlm_namespace *, struct ldlm_lock **,
                                void *req_cookie, ldlm_mode_t mode, int flags,
                                void *data);
 
+/**
+ * LVB operations.
+ * LVB is LDLM Value Block. This is a special opaque (to LDLM) value that could
+ * be assotiated with an LDLM lock and transferred from client to server and
+ * back.
+ *
+ * Currently LVBs are used by OSC-OST code to maintain current object size/times
+ */
 struct ldlm_valblock_ops {
         int (*lvbo_init)(struct ldlm_resource *res);
         int (*lvbo_update)(struct ldlm_resource *res,
@@ -375,12 +423,16 @@ struct ldlm_valblock_ops {
                            int increase);
 };
 
+/**
+ * LDLM pools related, type of lock pool n the namespace.
+ * Greedy means release cached locks agressively
+ */
 typedef enum {
         LDLM_NAMESPACE_GREEDY = 1 << 0,
         LDLM_NAMESPACE_MODEST = 1 << 1
 } ldlm_appetite_t;
 
-/*
+/**
  * Default values for the "max_nolock_size", "contention_time" and
  * "contended_locks" namespace tunables.
  */
@@ -388,6 +440,27 @@ typedef enum {
 #define NS_DEFAULT_CONTENTION_SECONDS 2
 #define NS_DEFAULT_CONTENDED_LOCKS 32
 
+/**
+ * LDLM Namespace.
+ *
+ * Namespace serves to contain locks related to particluar service.
+ * There are two kinds of namespaces:
+ * - Server namespace has knowledge of all locks and is therefore authoritative
+ *   to make decisions like what locks could be granted and what conflicts
+ *   exist during new lock enqueue.
+ * - Client namespace only has limited knowledge about locks in the namespace,
+ *   only seeing locks held by the client.
+ *
+ * Every Lustre service has one server namespace present on the server serving
+ * that service. Every client connected to the service has a client namespace
+ * for it.
+ * Every lock obtained by client in that namespace is actually represented by
+ * two in-memory locks. One on the server and one on the client. The locks are
+ * linked by a special cookie by which one node can tell to the other which lock
+ * it actually means during communications. Such locks are called remote locks.
+ * The locks held by server only without any reference to a client are called
+ * local locks.
+ */
 struct ldlm_namespace {
         /**
          * Namespace name. Used for logging, etc.
@@ -411,69 +484,122 @@ struct ldlm_namespace {
         __u64                  ns_orig_connect_flags;
 
         /**
-         * Hash table for namespace.
+         * Resource hash table for namespace.
+         * Hash table is organized as an array of \see RES_HASH_SIZE elements.
+         * Each element is a list_head linking all resources whose name hash is
+         * equal to the array position.
+         * \see ldlm_hash_fn for the actual hash function.
          */
         cfs_list_t            *ns_hash;
+        /**
+         * Lock protecting accesses to the namespace hashtable
+         */
         cfs_spinlock_t         ns_hash_lock;
 
          /**
-          * Count of resources in the hash.
+          * Number of resources in the hash.
           */
         __u32                  ns_refcount;
 
          /**
-          * All root resources in namespace.
+          * List of all root resources in namespace.
           */
         cfs_list_t             ns_root_list;
 
         /**
-         * Position in global namespace list.
+         * Position in global namespace list linking all namespaces on the node.
          */
         cfs_list_t             ns_list_chain;
 
         /**
-         * All root resources in namespace.
+         * List of unused locks for this namespace. This list is also called
+         * LRU lock list.
+         * Unused locks are locks with zero r/w refcounts. This list is only
+         * used on clients for lock caching purposes.
+         * When we want to release some locks voluntarily or if server want
+         * us to release some locks due to e.g. memory pressure, we take locks
+         * to release from the head of this list.
+         * Locks are linked via l_lru field in \see struct ldlm_lock.
          */
         cfs_list_t             ns_unused_list;
+        /** Number locks in the LRU list above */
         int                    ns_nr_unused;
+        /** All accesses to LRU list must be made under this lock */
         cfs_spinlock_t         ns_unused_lock;
 
+        /**
+         * Maximum number of locks permitted in the LRU. If 0, means locks
+         * are managed by pools and ther is no preset limit, rather it is all
+         * cpontrolled by available memory on this client and on server
+         */
         unsigned int           ns_max_unused;
+        /** Maximum allowed age (last used time) for locks in the LRU */
         unsigned int           ns_max_age;
+        /**
+         * Server only: number of times we evicted clients due to lack of reply
+         * to ASTs
+         */
         unsigned int           ns_timeouts;
-         /**
-          * Seconds.
-          */
+        /**
+         * Seconds.
+         * Appears to be currently unused. Should be removed.
+         */
         unsigned int           ns_ctime_age_limit;
 
         /**
          * Next debug dump, jiffies.
+         * Used to rate-limit ldlm_namespace_dump calls.
+         * \see ldlm_namespace_dump. Increased by 10 seconds every time
+         * its called.
          */
         cfs_time_t             ns_next_dump;
 
+        /** Number of locks in this namespace */
         cfs_atomic_t           ns_locks;
+        /** Number of resources in this namespace */
         __u64                  ns_resources;
+
+        /** "policy" function that does actual lock conflict determination */
         ldlm_res_policy        ns_policy;
+
+        /**
+         * LVB operations for this namespace.
+         * \see struct ldlm_valblock_ops
+         */
         struct ldlm_valblock_ops *ns_lvbo;
+        /**
+         * Used by filter code to store pointer to obd of the service
+         * Should be dropped in favor of \a ns_obd
+         */
         void                  *ns_lvbp;
+        /**
+         * Wait queue used by __ldlm_namespace_free. Get woken up every time
+         * a resource is removed.
+         */
         cfs_waitq_t            ns_waitq;
+        /** ldlm pool structure for this namespace */
         struct ldlm_pool       ns_pool;
+        /** Definition of how eagerly we need to release unused locks from LRU*/
         ldlm_appetite_t        ns_appetite;
 
         /**
          * If more than \a ns_contended_locks found, the resource is considered
          * to be contended.
+         * Lock enqueues might specify that no contended locks should be granted
          */
         unsigned               ns_contended_locks;
 
         /**
-         * The resource remembers contended state during \a ns_contention_time,
-         * in seconds.
+         * The resources in this namespace remember contended state during
+         * \a ns_contention_time, in seconds.
          */
         unsigned               ns_contention_time;
 
         /**
-         * Limit size of nolock requests, in bytes.
+         * Limit size of contended extent locks, in bytes.
+         * If extended lock is requested for more then this much bytes and
+         * caller instructs us not to grant contended locks, we would disregard
+         * such a request.
          */
         unsigned               ns_max_nolock_size;
 
@@ -482,9 +608,18 @@ struct ldlm_namespace {
          */
         struct obd_device     *ns_obd;
 
-        struct adaptive_timeout ns_at_estimate;/* estimated lock callback time*/
+        /**
+         * estimated lock callback time.
+         * Used by AT code to avoid spurious client evictions due to
+         * unresponsiveness where in fact it is network or overall system load
+         * is at fault
+         */
+        struct adaptive_timeout ns_at_estimate;
 };
 
+/**
+ * Returns 1 if namespace \param ns is a client namespace
+ */
 static inline int ns_is_client(struct ldlm_namespace *ns)
 {
         LASSERT(ns != NULL);
@@ -495,6 +630,9 @@ static inline int ns_is_client(struct ldlm_namespace *ns)
         return ns->ns_client == LDLM_NAMESPACE_CLIENT;
 }
 
+/**
+ * Returns 1 if namespace \param ns is a server namespace
+ */
 static inline int ns_is_server(struct ldlm_namespace *ns)
 {
         LASSERT(ns != NULL);
@@ -505,6 +643,9 @@ static inline int ns_is_server(struct ldlm_namespace *ns)
         return ns->ns_client == LDLM_NAMESPACE_SERVER;
 }
 
+/**
+ * Returns 1 if this namespace supports lru_resize
+ */
 static inline int ns_connect_lru_resize(struct ldlm_namespace *ns)
 {
         LASSERT(ns != NULL);
@@ -512,26 +653,29 @@ static inline int ns_connect_lru_resize(struct ldlm_namespace *ns)
 }
 
 /*
- *
- * Resource hash table
+ * Resource hash table definitions.
+ * \see struct ldlm_namespace ns_hash member
  *
  */
-
 #define RES_HASH_BITS 12
 #define RES_HASH_SIZE (1UL << RES_HASH_BITS)
 #define RES_HASH_MASK (RES_HASH_SIZE - 1)
 
 struct ldlm_lock;
 
+/** Type for blocking callback function of a lock. */
 typedef int (*ldlm_blocking_callback)(struct ldlm_lock *lock,
                                       struct ldlm_lock_desc *new, void *data,
                                       int flag);
+/** Type for completion callback function of a lock */
 typedef int (*ldlm_completion_callback)(struct ldlm_lock *lock, int flags,
                                         void *data);
+/** Type for glimpse callback function of a lock */
 typedef int (*ldlm_glimpse_callback)(struct ldlm_lock *lock, void *data);
+/** Type for weight callback function of a lock */
 typedef unsigned long (*ldlm_weigh_callback)(struct ldlm_lock *lock);
 
-/* Interval node data for each LDLM_EXTENT lock */
+/** Interval node data for each LDLM_EXTENT lock */
 struct ldlm_interval {
         struct interval_node li_node;   /* node for tree mgmt */
         cfs_list_t           li_group;  /* the locks which have the same
@@ -539,18 +683,25 @@ struct ldlm_interval {
 };
 #define to_ldlm_interval(n) container_of(n, struct ldlm_interval, li_node)
 
-/* the interval tree must be accessed inside the resource lock. */
+/**
+ * Interval tree for extent locks.
+ * the interval tree must be accessed under the resource lock.
+ * Interval trees are used for granted extent locks to speed up conflicts
+ * lookup. See ldlm/interval_tree.c for more details.
+ */
 struct ldlm_interval_tree {
-        /* tree size, this variable is used to count
-         * granted PW locks in ldlm_extent_policy()*/
+        /** Tree size. */
         int                   lit_size;
         ldlm_mode_t           lit_mode; /* lock mode */
-        struct interval_node *lit_root; /* actually ldlm_interval */
+        struct interval_node *lit_root; /* actual ldlm_interval */
 };
 
+/**
+ * Whenever to track references to exports by ldlm locks
+ */
 #define LUSTRE_TRACKS_LOCK_EXP_REFS (1)
 
-/* Cancel flag. */
+/** Cancel flags. */
 typedef enum {
         LCF_ASYNC      = 0x1, /* Cancel locks asynchronously. */
         LCF_LOCAL      = 0x2, /* Cancel locks locally, not notifing server */
@@ -558,13 +709,23 @@ typedef enum {
                                * in the same RPC */
 } ldlm_cancel_flags_t;
 
+/**
+ * LDLM lock structure
+ *
+ * Represents actual ldlm lock and its state in memory
+ */
 struct ldlm_lock {
         /**
+         * Local lock handle.
+         * When remote side wants to tell us about a lock, they address it by
+         * this handle.
          * Must be first in the structure.
          */
         struct portals_handle    l_handle;
         /**
          * Lock reference count.
+         * This is how many users have pointers to actual structure, so that
+         * we do not accidentally free lock structure that is in use.
          */
         cfs_atomic_t             l_refc;
         /**
@@ -573,15 +734,19 @@ struct ldlm_lock {
          */
         cfs_spinlock_t           l_lock;
         /**
+         * Pointer to actual resource this lock is in.
          * ldlm_lock_change_resource() can change this.
          */
         struct ldlm_resource    *l_resource;
         /**
-         * Protected by ns_hash_lock. List item for client side lru list.
+         * List item for client side lru list.
+         * Protected by ns_hash_lock in struct ldlm_namespace.
          */
         cfs_list_t               l_lru;
         /**
-         * Protected by lr_lock, linkage to resource's lock queues.
+         * Linkage to resource's lock queues according to current lock state.
+         * (could be granted, waiting or converting)
+         * Protected by lr_lock in struct ldlm_resource.
          */
         cfs_list_t               l_res_link;
         /**
@@ -594,7 +759,8 @@ struct ldlm_lock {
          */
         cfs_hlist_node_t         l_exp_hash;
         /**
-         * Protected by lr_lock. Requested mode.
+         * Requested mode.
+         * Protected by lr_lock.
          */
         ldlm_mode_t              l_req_mode;
         /**
@@ -602,42 +768,70 @@ struct ldlm_lock {
          */
         ldlm_mode_t              l_granted_mode;
         /**
-         * Lock enqueue completion handler.
+         * Lock completion handler pointer
+         * Called when the lock is granted.
          */
         ldlm_completion_callback l_completion_ast;
         /**
-         * Lock blocking ast handler.
+         * Lock blocking ast handler pointer.
+         * It plays two roles:
+         * - as a notification of an attempt to queue a conflicting lock (once)
+         * - as a notification when the lock is being cancelled.
+         *
+         * As such the typically it's called twice: once for the initial
+         * conflict and then once more when the last user went away and the lock
+         * is cancelled (could happen recursively).
          */
         ldlm_blocking_callback   l_blocking_ast;
         /**
          * Lock glimpse handler.
+         * Glimpse handler is used to obtain LVB updates from a client by
+         * server
          */
         ldlm_glimpse_callback    l_glimpse_ast;
+
+        /** apparently used "weight" handler. To be removed? */
         ldlm_weigh_callback      l_weigh_ast;
 
         /**
          * Lock export.
+         * This is a pointer to actual client export for locks that were granted
+         * to clients.
+         * Used server-side.
          */
         struct obd_export       *l_export;
         /**
          * Lock connection export.
+         * Pointer to server export on a client.
          */
         struct obd_export       *l_conn_export;
 
         /**
          * Remote lock handle.
+         * If the lock is remote, this is the handle of the other side lock
+         * (l_handle)
          */
         struct lustre_handle     l_remote_handle;
 
+        /**
+         * Representation of private data specific for a lock type.
+         * Examples are: extent range for extent lock or
+         * bitmask for ibits locks */
         ldlm_policy_data_t       l_policy_data;
 
-        /*
-         * Protected by lr_lock. Various counters: readers, writers, etc.
+        /**
+         * Lock state flags.
+         * Like whenever we received any blocking requests for this block, etc.
+         * Protected by lr_lock.
          */
         __u64                 l_flags;
+        /**
+         * Lock r/w usage counters.
+         * Protected by lr_lock.
+         */
         __u32                 l_readers;
         __u32                 l_writers;
-        /*
+        /**
          * Set for locks that were removed from class hash table and will be
          * destroyed when last reference to them is released. Set by
          * ldlm_lock_destroy_internal().
@@ -653,17 +847,19 @@ struct ldlm_lock {
          */
         cfs_waitq_t           l_waitq;
 
-        /** 
+        /**
          * Seconds. it will be updated if there is any activity related to 
          * the lock, e.g. enqueue the lock or send block AST.
          */
         cfs_time_t            l_last_activity;
 
         /**
+         * Time last used by e.g. being matched by lock match.
          * Jiffies. Should be converted to time if needed.
          */
         cfs_time_t            l_last_used;
 
+        /** Originally requested extent for the extent lock */
         struct ldlm_extent    l_req_extent;
 
         /*
@@ -676,52 +872,78 @@ struct ldlm_lock {
         __u32                 l_lvb_len;
         void                 *l_lvb_data;
 
+        /** Private storage for lock user. Opaque to LDLM. */
         void                 *l_ast_data;
-        cfs_spinlock_t        l_extents_list_lock;
-        cfs_list_t            l_extents_list;
-
-        cfs_list_t            l_cache_locks_list;
 
         /*
          * Server-side-only members.
          */
 
-        /** connection cookie for the client originated the operation. */
+        /**
+         * Connection cookie for the client originating the operation.
+         * Used by Commit on Share (COS) code. Currently only used for
+         * inodebits locks on MDS.
+         */
         __u64                 l_client_cookie;
 
         /**
-         * Protected by elt_lock. Callbacks pending.
+         * List item for locks waiting for cancellation from clients.
+         * The lists this could be linked into are:
+         * waiting_locks_list (protected by waiting_locks_spinlock),
+         * then if the lock timed out, it is moved to
+         * expired_lock_thread.elt_expired_locks for further processing.
+         * (Protected by elt_lock)
          */
         cfs_list_t            l_pending_chain;
 
+        /**
+         * Set when lock is sent blocking AST. Time in seconds when timeout
+         * is reached and client holding this lock could be evicted.
+         * This timeout could be further extended by e.g. certain IO activity
+         * under this lock.
+         * \see ost_rw_prolong_locks
+         */
         cfs_time_t            l_callback_timeout;
 
         /**
-         * Pid which created this lock.
+         * Local pid of process which created this lock.
          */
         __u32                 l_pid;
 
         /**
-         * For ldlm_add_ast_work_item().
+         * List item ldlm_add_ast_work_item() for case of blocking ASTs.
          */
         cfs_list_t            l_bl_ast;
         /**
-         * For ldlm_add_ast_work_item().
+         * List item ldlm_add_ast_work_item() for case of completion ASTs.
          */
         cfs_list_t            l_cp_ast;
         /**
-         * For ldlm_add_ast_work_item().
+         * For ldlm_add_ast_work_item() for "revoke" AST used in COS.
          */
         cfs_list_t            l_rk_ast;
 
+        /** Pointer to a conflicting lock that caused blocking AST to be sent
+         * for this lock */
         struct ldlm_lock     *l_blocking_lock;
+        /**
+         * Number of times blocking AST was sent for this lock.
+         * This is for debugging. Valid values are 0 and 1, if there is an
+         * attempt to send blocking ast more than once, an assertion would be
+         * hit. \see ldlm_work_bl_ast_lock
+         */
         int                   l_bl_ast_run;
 
         /**
          * Protected by lr_lock, linkages to "skip lists".
+         * For more explanations of skip lists see ldlm/ldlm_inodebits.c
          */
         cfs_list_t            l_sl_mode;
         cfs_list_t            l_sl_policy;
+
+        /**
+         * Reference tracking structure to debug leaked locks.
+         */
         struct lu_ref         l_reference;
 #if LUSTRE_TRACKS_LOCK_EXP_REFS
         /* Debugging stuff for bug 20498, for tracking export
@@ -735,34 +957,74 @@ struct ldlm_lock {
 #endif
 };
 
+/**
+ * LDLM resource description.
+ * Basically, resource is a representation for a single object.
+ * Object has a name which is currently 4 64 bit integers.
+ * LDLM user is responsible for creation of a mapping between objects it wants
+ * to be protected and resource names.
+ *
+ * A resurce can only hold locks of a single lock type.
+ */
 struct ldlm_resource {
+        /** Back link to namespace */
         struct ldlm_namespace *lr_namespace;
 
-        /* protected by ns_hash_lock */
+        /**
+         * List item for list in namespace hash.
+         * protected by ns_hash_lock
+         */
         cfs_list_t             lr_hash;
+        /* XXX Remove lr_parent/child and its logic ASAP */
         struct ldlm_resource  *lr_parent;   /* 0 for a root resource */
         cfs_list_t             lr_children; /* list head for child resources */
         cfs_list_t             lr_childof;  /* part of ns_root_list if root res,
                                              * part of lr_children if child */
+        /** Spinlock to protect locks under this resource. */
         cfs_spinlock_t         lr_lock;
 
-        /* protected by lr_lock */
+        /**
+         * protected by lr_lock
+         * @{ */
+        /**
+         * List of locks in granted state
+         */
         cfs_list_t             lr_granted;
+        /**
+         *List of locks waiting to change their granted mode (converted)
+         */
         cfs_list_t             lr_converting;
+        /**
+         * List of locks that could not be granted due to conflicts and
+         * that are waiting for conflicts to go away */
         cfs_list_t             lr_waiting;
+        /** @} */
+
+        /* XXX No longer needed? Remove ASAP */
         ldlm_mode_t            lr_most_restr;
+
+        /**
+         * Type of locks this resource can hold
+         * Only one type per resource.
+         */
         ldlm_type_t            lr_type; /* LDLM_{PLAIN,EXTENT,FLOCK} */
+
+        /** Resource name */
         struct ldlm_res_id     lr_name;
+        /** Reference count for this resource */
         cfs_atomic_t           lr_refcount;
 
+        /**
+         * Interval trees (only for extent locks) for all modes of this resource
+        */
         struct ldlm_interval_tree lr_itree[LCK_MODE_NUM];  /* interval trees*/
 
-        /* Server-side-only lock value block elements */
+        /** Server-side-only lock value block elements */
         cfs_semaphore_t        lr_lvb_sem;
         __u32                  lr_lvb_len;
         void                  *lr_lvb_data;
 
-        /* when the resource was considered as contended */
+        /** when the resource was last considered as contended */
         cfs_time_t             lr_contention_time;
         /**
          * List of references to this resource. For debugging.
@@ -770,26 +1032,18 @@ struct ldlm_resource {
         struct lu_ref          lr_reference;
 };
 
-struct ldlm_ast_work {
-        struct ldlm_lock      *w_lock;
-        int                    w_blocking;
-        struct ldlm_lock_desc  w_desc;
-        cfs_list_t             w_list;
-        int                    w_flags;
-        void                  *w_data;
-        int                    w_datalen;
-};
-
-/* ldlm_enqueue parameters common */
+/**
+ * Common ldlm_enqueue parameters
+ */
 struct ldlm_enqueue_info {
-        __u32 ei_type;   /* Type of the lock being enqueued. */
-        __u32 ei_mode;   /* Mode of the lock being enqueued. */
-        void *ei_cb_bl;  /* blocking lock callback */
-        void *ei_cb_cp;  /* lock completion callback */
-        void *ei_cb_gl;  /* lock glimpse callback */
-        void *ei_cb_wg;  /* lock weigh callback */
-        void *ei_cbdata; /* Data to be passed into callbacks. */
-        short ei_async:1; /* async request */
+        __u32 ei_type;   /** Type of the lock being enqueued. */
+        __u32 ei_mode;   /** Mode of the lock being enqueued. */
+        void *ei_cb_bl;  /** blocking lock callback */
+        void *ei_cb_cp;  /** lock completion callback */
+        void *ei_cb_gl;  /** lock glimpse callback */
+        void *ei_cb_wg;  /** lock weigh callback */
+        void *ei_cbdata; /** Data to be passed into callbacks. */
+        short ei_async:1; /** async request */
 };
 
 extern struct obd_ops ldlm_obd_ops;
@@ -797,6 +1051,11 @@ extern struct obd_ops ldlm_obd_ops;
 extern char *ldlm_lockname[];
 extern char *ldlm_typename[];
 extern char *ldlm_it2str(int it);
+
+/**
+ * Support function for lock information printing into debug logs.
+ * \see LDLM_DEBUG
+ */
 #ifdef LIBCFS_DEBUG
 #define ldlm_lock_debug(cdls, level, lock, file, func, line, fmt, a...) do { \
         CFS_CHECK_STACK();                                              \
@@ -817,6 +1076,9 @@ void _ldlm_lock_debug(struct ldlm_lock *lock, __u32 mask,
                       ...)
         __attribute__ ((format (printf, 4, 5)));
 
+/**
+ * Rate-limited version of lock printing function
+ */
 #define LDLM_DEBUG_LIMIT(mask, lock, fmt, a...) do {                    \
         static cfs_debug_limit_state_t _ldlm_cdls;                      \
         ldlm_lock_debug(&_ldlm_cdls, mask, lock,                        \
@@ -827,6 +1089,7 @@ void _ldlm_lock_debug(struct ldlm_lock *lock, __u32 mask,
 #define LDLM_ERROR(lock, fmt, a...) LDLM_DEBUG_LIMIT(D_ERROR, lock, fmt, ## a)
 #define LDLM_WARN(lock, fmt, a...)  LDLM_DEBUG_LIMIT(D_WARNING, lock, fmt, ## a)
 
+/** Non-rate-limited lock printing function for debugging purposes */
 #define LDLM_DEBUG(lock, fmt, a...)   do {                              \
         ldlm_lock_debug(NULL, D_DLMTRACE, lock,                         \
                         __FILE__, __FUNCTION__, __LINE__,               \
@@ -839,6 +1102,10 @@ void _ldlm_lock_debug(struct ldlm_lock *lock, __u32 mask,
          ((void)0)
 #endif
 
+/**
+ * Just a fancy CDEBUG call with log level preset to LDLM_DEBUG.
+ * For the cases where we do not have actual lock to print along
+ * with a debugging message that is ldlm-related */
 #define LDLM_DEBUG_NOLOCK(format, a...)                 \
         CDEBUG(D_DLMTRACE, "### " format "\n" , ##a)
 
